version: '3.7'

services:
  loki:
    image: grafana/loki:1.6.0
    command: -config.file=/etc/loki/local-config.yaml
    networks: 
      - proxy
      - monitoring
    ports:
      - 3100:3100
    volumes: 
      - loki-data:/tmp/loki
    deploy:
      mode: replicated
      replicas: 1
      restart_policy:
        condition: on-failure
      placement:
        constraints: 
        - "node.hostname == {{ hostvars[groups['manager'][0]]['ansible_hostname'] }}"

  promtail:
    image: grafana/promtail:1.6.0
    command: -config.file=/etc/promtail/config.yml
    networks:
      - monitoring
    ports:
      - "9080:9080"
    volumes:
      - /var/log:/var/log
    deploy:
      mode: global
      restart_policy:
        condition: on-failure
      placement:
        constraints: 
        - node.platform.os == linux

networks:
  monitoring:
    driver: overlay
    attachable: true
    name: monitoring
  proxy:
    driver: overlay
    external: true

volumes:
  loki-data: